All of lore.kernel.org
 help / color / mirror / Atom feed
From: "Darrick J. Wong" <djwong@kernel.org>
To: djwong@kernel.org, guaneryu@gmail.com
Cc: linux-xfs@vger.kernel.org, fstests@vger.kernel.org, guan@eryu.me
Subject: [PATCH 03/10] fstests: add tool migrate group membership data to test files
Date: Tue, 25 May 2021 18:46:59 -0700	[thread overview]
Message-ID: <162199361915.3744214.4666565580602969000.stgit@locust> (raw)
In-Reply-To: <162199360248.3744214.17042613373014687643.stgit@locust>

From: Darrick J. Wong <djwong@kernel.org>

Create a tool to migrate the mapping of tests <-> groups out of the
group file and into the individual test file as a _set_seq_and_groups
call.  In the next patches we'll rewrite all the test files and auto
generate the group files from the tests.

Signed-off-by: Darrick J. Wong <djwong@kernel.org>
---
 tools/convert-group |   64 +++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 64 insertions(+)
 create mode 100755 tools/convert-group


diff --git a/tools/convert-group b/tools/convert-group
new file mode 100755
index 00000000..e7af10e0
--- /dev/null
+++ b/tools/convert-group
@@ -0,0 +1,64 @@
+#!/bin/bash
+
+# Move group tags from the groups file into the test files themselves.
+
+if [ -z "$1" ] || [ "$1" = "--help" ]; then
+	echo "Usage: $0 test_dir [test_dirs...]"
+	exit 1
+fi
+
+obliterate_group_file() {
+	sed -e 's/^#.*$//g' < group | while read test groups; do
+		if [ -z "$test" ]; then
+			continue;
+		elif [ ! -e "$test" ]; then
+			echo "Ignoring unknown test file \"$test\"."
+			continue
+		fi
+		sed -e '/^seqres=\$RESULT_DIR\/\$seq$/d' \
+		    -e '/^echo "QA output created by \$seq"$/d' \
+		    -e '/^here=`pwd`$/d' \
+		    -e '/^tmp=\/tmp\/\$\$$/d' \
+		    -e '/^status=1.*failure.*is.*the.*default/d' \
+		    -e '/^status=1.*FAILure.*is.*the.*default/d' \
+		    -e '/^status=1.*success.*is.*the.*default/d' \
+		    -e '/^status=1.*default.*failure/d' \
+		    -e '/^echo.*QA output created by.*seq/d' \
+		    -e 's|^seq=.*$|. ./common/test_names\n_set_seq_and_groups '"$groups"'|g' \
+		    -i "$test"
+		if grep -q '^status=1$' "$test"; then
+			# Replace the "status=1" lines that don't have the usual
+			# "failure is the default" message if there's no other
+			# code between _set_seq_and_groups and status=1.
+			awk '
+BEGIN {
+	saw_groupinfo = 0;
+}
+{
+	if ($0 ~ /^_set_seq_and_groups/) {
+		saw_groupinfo = 1;
+		printf("%s\n", $0);
+	} else if ($0 ~ /^status=1$/) {
+		if (saw_groupinfo == 0) {
+			printf("%s\n", $0);
+		}
+	} else if ($0 == "") {
+		printf("\n");
+	} else {
+		saw_groupinfo = 0;
+		printf("%s\n", $0);
+	}
+}
+' < "$test" > "$test.new"
+			cat "$test.new" > "$test"
+			rm -f "$test.new"
+		fi
+	done
+}
+
+curr_dir="$PWD"
+for tdir in "$@"; do
+	cd "tests/$tdir"
+	obliterate_group_file
+	cd "$curr_dir"
+done


  parent reply	other threads:[~2021-05-26  1:47 UTC|newest]

Thread overview: 20+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2021-05-26  1:46 [PATCHSET RFC 00/10] fstests: move test group lists into " Darrick J. Wong
2021-05-26  1:46 ` [PATCH 01/10] fstests: fix group check in new script Darrick J. Wong
2021-05-26  1:46 ` [PATCH 02/10] fstests: refactor setting test sequence number variables Darrick J. Wong
2021-05-26  1:46 ` Darrick J. Wong [this message]
2021-05-26  1:47 ` [PATCH 04/10] fstests: move test group info to test files Darrick J. Wong
2021-06-03  4:58   ` Eric Biggers
2021-06-03 15:23     ` Darrick J. Wong
2021-05-26  1:47 ` [PATCH 05/10] fstests: clean up open-coded golden output Darrick J. Wong
2021-05-26  1:47 ` [PATCH 06/10] fstests: automatically generate group files Darrick J. Wong
2021-05-26  1:47 ` [PATCH 07/10] fstests: convert nextid to use automatic group generation Darrick J. Wong
2021-05-26  1:47 ` [PATCH 08/10] fstests: adapt the new test script to our new group tagging scheme Darrick J. Wong
2021-05-26  1:47 ` [PATCH 09/10] fstests: remove group files Darrick J. Wong
2021-05-26  1:47 ` [PATCH 10/10] fstests: remove test group management code Darrick J. Wong
2021-06-03  6:32 ` [PATCHSET RFC 00/10] fstests: move test group lists into test files Amir Goldstein
2021-06-03 15:34   ` Darrick J. Wong
2021-06-03 16:56     ` Amir Goldstein
2021-06-03 22:21       ` Darrick J. Wong
2021-06-06 14:44 ` Eryu Guan
2021-06-06 18:05   ` Darrick J. Wong
2021-06-07 17:06     ` Darrick J. Wong

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=162199361915.3744214.4666565580602969000.stgit@locust \
    --to=djwong@kernel.org \
    --cc=fstests@vger.kernel.org \
    --cc=guan@eryu.me \
    --cc=guaneryu@gmail.com \
    --cc=linux-xfs@vger.kernel.org \
    --subject='Re: [PATCH 03/10] fstests: add tool migrate group membership data to test files' \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link

This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.